/*		 ICP-PCI Kernel module free public release
 *
 *		       Copyright (C) 1996-99 GOM mbH.
 *	         Rebenring 33, 38106 Braunschweig, GERMANY
 *		            All rights reserved
 *
 * $Id: swtrig_icpci.c,v 5.1.2.1 1999/06/03 08:57:43 matthias Exp $
 *
 */

/*
 * Defines:
 */

#define	DEFAULT_DEVICE		"/dev/ic0vsI"

/*
 * Includes:
 */

#include	<stdio.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<errno.h>
#include	<fcntl.h>
#include	<getopt.h>

#include	<sys/ioctl.h>

#ifdef linux
#  include	<linux/limits.h>	/* PATH_MAX */
#endif

#include	"icpciExt.h"

/*
 * Globals:
 */

  int	dev_fd;

/*
 * Prototypes:
 */

void close_and_clear (void);

void
close_and_clear (void) {

  if (close (dev_fd) < 0) {
    perror ("close");
  }
}

int
main (int argc, char *argv[]) {

  char	dev_file[PATH_MAX] = DEFAULT_DEVICE;  

  int	option;

  int	wait_key = FALSE;

  while (1) {
    if ((option = getopt (argc, argv, "f:k")) == -1) break;
    switch (option) {
    case 'f':
	if (!optarg) {
	  printf ("No or wrong special device file given, "
		  "using %s.\n", DEFAULT_DEVICE);
	} else {
	  strcpy (dev_file, optarg);
	}
      break;
    case 'k':
      wait_key = TRUE;
      break;
    case '?':
    default:
      printf ("Usage: swtrig_icpci [-f special device file "
	      "(/dev/ic0idI)]\n");
      printf ("                    [-k wait for 'press any key']\n");
      exit (EXIT_FAILURE);
    }
  }

  if ((dev_fd = open (dev_file, O_RDWR)) < 0) {
    perror ("open");
    exit (EXIT_FAILURE);
  }
  
  if (atexit (close_and_clear) < 0) {
    perror ("atexit");
    exit (EXIT_FAILURE);
  }
  
  if (wait_key) {
    fprintf (stderr, "Press any key to trigger board!\n");
    while (getchar() == 0) ;
  }

  if (ioctl (dev_fd, GIOC_CR_SET_SOFTTRIG, NULL) < 0) {
    perror ("ioctl");
    exit (EXIT_FAILURE);
  }

  exit (EXIT_SUCCESS);
}
